//Teodora Petrova 44514 variant 1
#include<iostream>
#include<cmath>
using namespace std;
double pi=3.1415;

class Shape
{
public:
	virtual void Create()=0;
	virtual float Area()=0;
	virtual float Perimeter()=0;
	virtual void translate(int x,int y)=0;
	virtual void print()=0;
};

class Triangle: public Shape
{
public:
	Triangle(){xa=ya=xb=yb=xc=yc=0;}
	void Create();
	float Area();
	float Perimeter();
	void translate(int x,int y);
	void print();
private:
	float side1()
	{ return sqrt((xb-xa)*(xb-xa)+(yb-ya)*(yb-ya));  }
	float side2()
	{  return  sqrt((xc-xb)*abs(xc-xb)+(yc-yb)*(yc-yb)); }
	 float side3()
	{  return sqrt((xc-xa)*(xc-xa)+(yc-ya)*(yc-ya));   }
	float xa,ya,xb,yb,xc,yc;
};

void Triangle::Create()
{ float a,A,b,B,c,C;
  cout<<"A: x="; cin>>a; xa=a; cout<<"y="; cin>>A; ya=A;
	cout<<"B: x="; cin>>b; xb=b; cout<<"y="; cin>>B; yb=B;
	cout<<"C: x="; cin>>c; xc=c; cout<<"y="; cin>>C; yc=C;
}
float Triangle::Area()
{ float a,b,c;
	a=side1();
	b=side2();
	c=side3();
	float p=(a+b+c)/2;
	return sqrt((p-a)*(p-b)*(p-c));
}
float Triangle::Perimeter()
{ 
	float a,b,c;
	a=side1(); b=side2(); c=side3();
	return a+b+c;
}
void Triangle::translate(int x,int y)
{
	xa=xa+x; ya=ya+y;
	xb+=x; yb+=y;
	xc+=x; yc+=y;
}
void Triangle::print()
{
	cout<<"Triangle: S="<<Area()<<" P="<<Perimeter();
}

class Circle:public Shape
{
public:
	Circle(): xc(0),yc(0),r(0){}
	Circle(int x,int y,int r):xc(x),yc(y),r(r){}
  void Create();
	float Area();
	float Perimeter();
	void translate(int x,int y);
	void print();
private:
	int xc,yc,r;
};

void Circle::Create()
{ int x,y,R;
  cout<<" centur: x="; cin>>x; xc=x;
	cout<<" y="; cin>>y; yc=y;
	cout<<"radius="; cin>>R; r=R;
}
float Circle::Area()
{ return float(pi*r*r); }

float Circle::Perimeter()
{ return float(2*pi*r); } 

void Circle::translate(int x,int y)
{
	xc+=x;
	yc+=y;
}
void Circle::print()
{
	cout<<"circle: S="<<Area()<<" P="<<Perimeter()<<"\n";
}


class Rectangle:public Shape
{
public:
	Rectangle(int a=0,int b=0,int c=0,int d=0,int s=0):xa(a),ya(b),xb(c),yb(d),side(s){}
  void Create();
	float Area();
	float Perimeter();
	void translate(int x,int y);
	void print();
private:
	int xa,ya,xb,yb,side; //side- strana neobrazuva6ta se ot dvete zadadeni to4ki
};
void Rectangle::Create()
{ int a,b,c,d,s;
	cout<<"A: x="; cin>>a; xa=a; cout<<"y="; cin>>b; ya=b;
	cout<<"B: x="; cin>>c; xb=c; cout<<"y="; cin>>d; yb=d;
	cout<<"strana ne svurzva6ta tezi dve tok4ki - "; cin>>s;
}
float Rectangle::Area()
{
	return sqrt(float(((xb-xa)*(xb-xa)+(yb-ya)*(xb-xa))*side));
}
float Rectangle::Perimeter()
{
	return 2*(sqrt(float((xb-xa)*(xb-xa)+(yb-ya)*(xb-xa)+side)));
}
void Rectangle::translate(int x,int y)
{
	xa+=x; ya+=y;
	xb+=x; yb+=y;
}
void Rectangle::print()
{
	cout<<"S="<<Area()<<" P="<<Perimeter()<<"\n";
}



class Square:public Rectangle
{
public:
	Square(int a=0,int b=0,int c=0,int d=0):Rectangle(a,b,c,d,int(sqrt(float((a-c)*(a-c)+(b-d)*(b-d))))) {}
	void print();
private:
	int xa,ya,xb,yb;
};

void Square::print()
{
	cout<<"Square: ";
	Rectangle::print();
}


class Shapes
{
public:
	void AddShape();
	void printShape(int);
	void calculateAllArea();
private:
	int num; //triabva konstruktor da inicializira tova s 0, zashtoto to ne e 0 po default
	Shape *(sh[50]);
};

void Shapes::AddShape()
{ char f;
	cout<<"Yputvane: t-triugulnik,c-okrujnost,r-pravougulnik,s-kvadrat \n";
	cout<<"Tip na figura? - " ; cin>>f;
	switch(f)
	{
	case('t'):{ sh[num]=new Triangle; Triangle tr; sh[num]=&tr; tr.Create(); num++; break; }
	case('c'):{ sh[num]=new Circle; Circle cir; sh[num]=&cir; cir.Create(); num++; break; }
	case('r'):{ sh[num]=new Rectangle; Rectangle rec; sh[num]=&rec; rec.Create(); num++; break; }
	case('s'):{ sh[num]=new Square; Square sq; sh[num]=&sq; sq.Create(); num++; break; }
	default: cout<<"Gre6no vuvejdane!\n";break;
	}

	//Tova, koeto si napravila tuk, realno e slednoto
	// 1 - suzdavash nov obekt na heap-a (new Triangle), kum koito sochi da kajem sh[0]
	// 2 - suzdavash lokalen obekt na stacka (Triangle tr)
	// 3 - nasochvash sh[0] kum obekta na stacka. vruzkata s obekta na heapa se gubi i ne mojesh da go osvobodish poveche (a ti i nikude ne vikash delete)
	// 4 - izvikva se create, lokalniat obekt se inicializira, no se unishtojava na kraia na bloka => sh[0] sochi kum prazna pamet
	// => ostavame bez inicializiran obekt i s edin zaguben (memory leak) na heapa obekt
}
void Shapes::printShape(int s)
{
	for(int i=0;i<num;i++)
	if(i==s) sh[i]->print();
}
void Shapes::calculateAllArea()
{
	float sum=0.0;
	for(int i=0;i<num;i++)
		sum+=sh[i]->Area();
	cout<<"Suma na licata - "<<sum<<"\n";
}
int main()
{
	Shapes *a;
	a->AddShape();
	//Triangle a;
	/*a.Create();*/
	system("pause");
	return 0;
}



//lipsva drugata zadacha?
