//Nikolay Vasilev fn: 44522, gr: 6
//#include "stdafx.h"
#include<iostream>
#include<fstream>
#include<math.h>
using namespace std;
class Ops{
public:
	virtual double _dim() const =0; //zashto double???
	virtual double f(double) const =0;
	virtual void print_safe() const =0;
};
class Vector:public Ops
{
private:
	double* V;
	int dim;
public:
	void Set(int =0);
	void initiate();
	Vector(int =0);
	Vector(const Vector&);
	~Vector(){delete []V;};
	Vector& operator=(const Vector&);
	Vector& add(const Vector&);
	Vector& scale(double);
	double f(double)const;
	double _dim() const {return dim;};
	void print_safe()const;
};
void Vector::Set(int a)
{
	V=new double[a];
	dim=a;
}
Vector::Vector(int a)
{	
	Set(a);
	dim=a;
}
Vector::Vector(const Vector& other)
{
	Set(other.dim);
	for(int i=0;i<dim;i++)
		V[i]=other.V[i];
	
}
Vector& Vector::operator=(const Vector& other)
{
	if(this!=&other)
	{	
		delete []V;
		dim=other.dim;
		V=new double [dim];
		for(int i=0;i<dim;i++)
			V[i]=other.V[i];
	}
	return*this;
}
void Vector::initiate()
{
	for(int i=0;i<dim;i++)
	{	
		cout<<"a"<<i<<"=";cin>>V[i];
	}
}
Vector& Vector::add(const Vector &other)
{	
	for(int i=0;i<min(dim,other.dim);i++)
	{
		V[i]+=other.V[i];
	}
	if(dim<other.dim) *this=other;
	return *this;
}
Vector& Vector::scale(double a)
{	
	for(int i=0;i<dim;i++)
	{
		V[i]*=a;
	}
	return *this;
}
double Vector::f(double a) const
{
	int b=a;
	if (b>dim) return -1;
	return V[b];
}
void Vector::print_safe()const
{
	ofstream fout("Vector.txt",ios::app);
	cout<<"(";
	fout<<"(";
	for(int i=0;i<dim;i++)
	{
		cout<<V[i]<<",";
		fout<<V[i]<<",";
	}
	cout<<")\n";
	fout<<")\n";
	fout.close();
}
class Polynome
{
private:
	double* coefs;
	int deg;
public:
	void initiate();
	Polynome(int =0);
	Polynome(const Polynome&);
	~Polynome(){delete []coefs;};
	Polynome& operator=(const Polynome&);
	Polynome& add(const Polynome&);
	Polynome& scale(double);
	double f(double)const;
	double _dim() const {return deg;};
	void print_safe()const;
};
Polynome::Polynome(int a)
{
	coefs=new double [a];
	deg=a;
}
Polynome::Polynome(const Polynome& other)
{
	deg=other.deg;
	coefs=new double[deg];
	for(int i=0;i<deg;i++)
	{
		coefs[i]=other.coefs[i];
	}
}
Polynome& Polynome::operator=(const Polynome& other)
{
	if (this!=&other){
		delete []coefs;
		deg=other.deg;
		coefs=new double[deg];
		for(int i=0;i<deg;i++)
		{
			coefs[i]=other.coefs[i];
		}
	}
	return *this;
}
Polynome& Polynome::add(const Polynome& other)
{
	for(int i=min(deg,other.deg);i>=0;i--)
	{
		coefs[i]+=other.coefs[i];
	}
	if(deg<other.deg) *this=other;
	return *this;
}
Polynome& Polynome::scale(double a)
{
	for(int i=0;i<deg;i++)
	{
		coefs[i]*=a;
	}
	return *this;
}
double Polynome::f(double a) const
{	
	double s=0;
	for (int i=deg;i>=0;i--)
	{
		s+=pow(a,i)*coefs[i];
	}
	return s;
}
void Polynome::print_safe()const
{
	ofstream fout("Polynome.dat",ios::app);
	cout<<"f(x)=";
	fout<<"f(x)=";
	for(int i=deg;i>=0;i--)
	{
		cout<<coefs[i]<<"x^"<<i<<"+";
		fout<<coefs[i]<<"x^"<<i<<"+";
	}
	cout<<"0\n";
	fout<<"0\n";
	fout.close();
}
double print_val(double val,int dim,Ops* Arr,int lenght)
{
	Ops* _new;
	int _l=0;
	for(int i=0;i<lenght;i++)
	{
		if(dim==Arr->_dim) _l++; //_dim e funkcia, triabva da e _dim(), taka ne se kompilira
	}
	_new=new Ops[_l];
	int j=0;
	for(int i=0;i<lenght;i++)
	{
		if(dim==Arr->_dim){ _l++;
			_new[j]=Arr[i];
			j++;
		}
	} //zashto triabva da pravish nov masiv??? dolnoto neshto moje da e prosto v gornia if

	ofstream fout("last.txt",ios::app);
	for(int i=0;i<_l;i++)
	{
		cout<<_new[i].f(val)<<" "; 
		fout<<_new[i].f(val)<<" ";
	}
	cout<<"\n";
	fout<<"\n";
	fout.close();
}
int main()
{
	Vector A(2);
	A.initiate();
	A.print_safe();
	return 0;
}

