//Nikolay Georgiev Kolev,44528,6th
//First task
//#include "stdafx.h"
#include <iostream>
#include <math.h>
#include <fstream>

using namespace std;

unsigned max (unsigned a, unsigned b ) 
{
    return (b<a)?a:b;    
}

template<class T>
class Sequence
{
public:
    Sequence(unsigned=10);
    Sequence(const Sequence&);
    ~Sequence();
    Sequence& operator=(const Sequence&);
    Sequence operator^(const Sequence&) const;
    Sequence operator()(unsigned,unsigned)const;
    void replace(T&, Sequence<T>&);
    

    void add(T);
private:
    T* ptr;
    unsigned length;
    unsigned maxLength;
};


template <class T>
Sequence<T>::Sequence(unsigned l)
{
    length=0;
    maxLength = l;
    ptr = new T[maxLength];
}

template <class T>
Sequence<T>::Sequence(const Sequence<T>& other)
{
    length=other.length;
    maxLength=other.maxLength;
    ptr=new T[other.maxLength];
    for(int i=0;i<length;i++)
        ptr[i] = other.ptr[i];
}

template <class T>
Sequence<T>::~Sequence()
{
    delete [] ptr;
}

template <class T>
void Sequence<T>::add(T element)
{
    if(length==maxLength)
    {
        cout<<"Memory error"<<endl;
        return;
    }
    ptr[length]=element;
    length++;
}

template <class T>
Sequence<T>& Sequence<T>::operator=(const Sequence<T>& other)
{
    if(this!=&other)
    {
        if(maxLength!=other.maxLength)
        {
            delete [] ptr;
            ptr=new T[other.maxLength];
        }
        for(int i=0;i<length;i++)
            ptr[i] = other.ptr[i];
    }
    return *this;
}
template <class T>
Sequence<T> Sequence<T>::operator^(const Sequence<T>& second) const
{
    Sequence temp(max(second.length,length));
        for(int i=0;i<length;i++)
            for(int j=0;j<second.length;i++)
                if(ptr[i]==second.ptr[j])
                    temp.add(ptr[i]);
    return temp;

}

template <class T>
Sequence<T> Sequence<T>::operator()(unsigned b,unsigned e)const
{
    Sequence temp(e-b);
    for(int i=b; i<e;i++)
        temp.add(ptr[i]);
    return temp;
}

template <class T>
void Sequence<T>::replace(T& item, Sequence<T>& replacement)
{
    Sequence temp(replacement.length*length);
    for(int i=0;i<length;i++)
    {
        if(ptr[i]==item)
            for(int j=0;j<replacement.length;j++)
                temp.add(replacement.ptr[j]);
        else temp.add(item);
    }
    (*this)=temp;
}

void main()
{
    Sequence<int> s;
    s.add(3);
    s.add(4);
    Sequence<int> s2;
    s2.add(1);
    int a=3;
    s.replace(a,s2);
    s2(1,3);
    Sequence<int> rez;
    rez=s^s2;
}

//Second task
//#include "stdafx.h"
//#include <iostream>
//using namespace std;

class EatingCreature
{
public:
    EatingCreature(char* n="",double =0,double =0);
    virtual ~EatingCreature();
    virtual double energyConsumption()const=0;
    virtual double foodPerDay()const=0;
    virtual double kmPerFood(double)const=0;
    virtual void print()const;
protected:
    char* name;
    double weigth;
    double kmPerDay;
};

void EatingCreature::print()const
{
    cout<<"Name: "<<name<<endl
        <<"weigth: "<<weigth<<endl
        <<"Kilometers per day: "<<kmPerDay<<endl;
}

EatingCreature::EatingCreature(char* n, double w, double kpd)
{
    name = new char[strlen(n)+1];
    strcpy(name,n);
    weigth=w;
    kmPerDay=kpd;
}

EatingCreature::~EatingCreature()
{
    delete [] name;
}

class Dog : public EatingCreature
{
public:
    Dog(char* n="",double =0,double =0);
    virtual double energyConsumption()const;
    virtual double foodPerDay()const;
    virtual double kmPerFood(double)const;
    virtual void print()const;
};

Dog::Dog(char* n,double w,double kpd):EatingCreature(n,w,kpd){}

double Dog::energyConsumption()const
{
    return weigth*kmPerDay;
}

double Dog::foodPerDay()const
{
    2*weigth*kmPerDay; //return lipsva
}

double Dog::kmPerFood(double k)const
{
     return foodPerDay()/kmPerDay*k; //otgovorut e k/(2*weight) (vij i po-dolu)
}

void Dog::print()const
{
    EatingCreature::print(); //niama nujda da se pishe, naslediava se
}

class American : public EatingCreature
{
public:
    American(char* n="",double =0,double =0,unsigned=0);
    virtual double energyConsumption()const;
    virtual double foodPerDay()const;
    virtual double kmPerFood(double)const;
    virtual void print()const;
private:
    unsigned timesToMD;
};

American::American(char* n,double w,double kpd ,unsigned ttm):EatingCreature(n,w,kpd)
{
    timesToMD = ttm;
}

double American::energyConsumption()const
{
    return 0.1*kmPerDay*weigth;
}

double American::foodPerDay()const
{
    return 0.1*kmPerDay*weigth+0.2*timesToMD; //ne: energyConsumption() + 0.2*timesToMD*energyConsumption()
}

double American::kmPerFood(double k)const
{
    return foodPerDay()/kmPerDay*k; //ne znam kak stigash do tazi formula, slednata e kato che li viarna: kmPerDay*k/foodPerDay()
}

void American::print()const
{
    EatingCreature::print();
    cout<<"Times to McDonalds: "<<timesToMD<<endl;
}

class Woman : public EatingCreature
{
public:
    Woman(char* n="",double =0,double =0,double=0, unsigned=0);
    double energyConsumption()const;
    double foodPerDay()const;
    double kmPerFood(double)const;
    void print()const;
private:
    double age;
    unsigned nervousness;
};

Woman::Woman(char* n,double w,double kpd,double a, unsigned n) //povtariat se imena na promenlivi.. triabva da kompilirash!
:EatingCreature(n,w,kpd)
{
    age=(a>=0)?a:0;
    inervousness = (n>0&&n<4)?n:2;
}
double Woman::energyConsumption()const
{
    return kmPerDay*weigth*nervousness;
}

double Woman::foodPerDay()const
{
    if(age>=12&&age<=42) return 0.5*kmPerDay*weigth*nervousness;
    if(age<12) return kmPerDay*weigth*nervousness;
    return 1.15*kmPerDay*weigth*nervousness;
}

double Woman::kmPerFood(double k)const
{
     return foodPerDay()/kmPerDay*k; //sushtoto
}

void Woman::print()const
{
    EatingCreature::print();
    cout<<"Age: "<<age<<endl
        <<"Nervousness: "<<nervousness<<endl;
}

void findCreature(EatingCreature** eCreatures,unsigned length,double food)
{
    EatingCreature* curr=0; //??????????
	//triabva ti vtora promenliva za tekushtiat maksimum (osven za tekushtia maksimalen element)
    for(int i=0;i<length;i++)
        if(eCreatures[i]->kmPerFood(food)>curr)curr=eCreatures[i];
    curr->print();
}

void main()
{

}
