#include<iostream>
using namespace std;

template <class T>
class Bag
{
public:
	T* pile;
	int numberInside;
	Bag(T* p=NULL, int n=0)
	{
		numberInside=n;
		pile= new T[numberInside];
		for (int i=0; i<n; i++)
		{
			pile[i]=p[i]; //triabva proveka if (p)
		}
	}
	Bag(const Bag& b)
	{
		numberInside=b.numberInside;
		pile = new T[numberInside];
		for (int i=0, i<numberInside; i++)
		{
			pile[i]= b.pile[i];
		}
	}
	Bag& operator = (const Bag& b)
	{
		if(this!=&b)
		{
			delete pile;
			numberInside=b.numberInside;
			pile = new T[numberInside];
			for (int i=0, i<numberInside; i++)
			{
				pile[i]= b.pile[i];
			}
		}
		return *this;
	}
	~Bag()
	{
		delete pile;
	}
	virtual int number()
	{
		return numberInside;
	}
	virtual bool operator+= (T element)
	{
		T*oldPile=pile;
		T*newPile= new T[numberInside+1]; //zashto samo s 1?
		for (int i=0; i<numberInside; i++)
		{
			newPile[i]=pile[i];
		}
		newPile[numberInside]=element;
		pile=newPile;
		numberInside++;
		delete oldPile;
		return true;
	}
	virtual Bag& operator^(Bag& bag)
	{
		Bag newBag;
		newBag.numberInside=numberInside;
		newBag.pile=new T[numberInside*bag.numberInside];
		int count=0;
		for (int i=0; i<numberInside; i++)
		{
			for (int j=0; j<bag.numberInside; j++)
			{
				if (pile[j]==pile[i])
				{
					newBag.pile[count]=pile[j];
					count++;
				}
			}
		}
		T*newPile=new T[count];
		for (int k=0; k<count; k++)
		{
			newPile[k]=newBag.pile[k];
		}
		Bag returnBag(newPile, count);
		delete newBag.pile;
		return returnBag;
	}
};

template <class T>
class Set: public Bag <T>
{
public:
	Set(T* p, int n): Bag (p,n)
	{}
	Set(const Set& s): Bag(s)
	{}
	Set& operator = (const Set& s)
	{
		if (this!=&s)
			Bag::operator = s;
		return *this;
	}
	~Set()
	{}
	int number()
	{
		return numberInside; //niama nujda da se povtaria koda na Bag, nali se naslediava
	}
	bool operator+= (T element)
	{
		for (int t=0; t<numberInside; t++)
		{
			if (pile[t]==element)
				return false;
		} //tuk sushto moje natatuk da se izpolzva Bag::operator +=
		numberInside++;
		T*oldPile=pile;
		T*newPile= new T[numberInside+1];
		for (int i=0; i<numberInside; i++)
		{
			newPile[i]=pile[i];
		}
		newPile[numberInside]=element;
		pile=newPile;
		delete oldPile;
		return true;
	}
	Set& operator^(Set& set)
	{
		Set newSet;
		newSet.numberInside=numberInside;
		newSet.pile=new T[numberInside];
		int count=0;
		for (int i=0; i<numberInside; i++)
		{
			for (int j=0; j<bag.numberInside; j++)
			{
				if (pile[j]==pile[i])
				{
					newBag.pile[count]=pile[j]; //tuk moje da ima break; tui kato tova e Set ne moje da se nameri drug element s tova uslovie
					count++;
				}
			}
		}
		T*newPile=new T[count];
		for (int k=0; k<count; k++)
		{
			newPile[k]=newSet.pile[k];
		}
		Set returnSet(newPile, count); //zashto triabva da pravish nov set?
		delete newSet;
		return returnSet;
	}
};

void main()
{
	int intSet1[10]={1,2,3,4,5,6,7,8,9,10};
	int intSet2[5]={1,3,5,7,9};
	int intSet3[5]={2,4,6,8,10};
	
	int intBag1[15]={1,2,3,3,4,5,5,5,6,7,7,8,8,9,10};
	int intBag2[9]={1,3,3,5,5,5,7,7,9};
	int intBag3[6]={2,4,6,8,8,10};

	Set <int> set1(intSet1, 10);
	Set <int> set2(intSet2, 5);
	Set <int> set3(intSet3, 5);

	Bag <int> bag1(intBag1, 15);
	Bag <int> bag2(intBag2, 9);
	Bag <int> bag3(intBag3, 6);
}