#include<iostream>
#include<math.h>
using namespace std;
class Shape
{
public:
	virtual void Create()=0;
	virtual float Area()=0;
	virtual float Perimeter()=0;
	virtual void translate(int x, int y)=0;
	virtual void print()=0;
};

class Point
{
private:
	float x,y;
public:
	Point(float x=0, float y=0)
	{
		this->x=x;
		this->y=y;
	}
	Point(const Point& p)
	{
		x=p.x;
		y=p.y;
	}
	Point& operator = (const Point& p)
	{
		if (this!=&p)
		{
			x=p.x;
			y=p.y;
		}
		return *this;
	}
	~Point(){}
	float lengthToPoint(const Point&p)
	{
		return sqrt((x-p.x)*(x-p.x)+(y-p.y)*(y-p.y));
	}
	void readPoint()
	{
		cout<<"x=";
		cin>>x;
		cout<<"y=";
		cin>>y;
	}
	void moveXcoord(int X)
	{
		x+=X;
	}
	void moveYcoord(int Y)
	{
		y+=Y;
	}
	void printPoint() const
	{
		cout<<"("<<x<<","<<y<<")"<<endl;
	}
	float getYcoord()
	{
		return y;
	}
	float getXcoord()
	{
		return x;
	}
};
class Circle: public Shape
{
private:
	Point center;
	float radius;
public:
	Circle(Point c=(0,0), float r=0)
	{
		center=c;
		radius=r;
	}
	~Circle(){}
	void Create()
	{
		Point p;
		cout<<"Point: ";
		p.readPoint();
		center=p;
		float r;
		cout<<"Radius: ";
		cin>>r;
		radius=r;
	}
	float Area()
	{
		return radius*radius*3.14;
	}
	float Perimeter()
	{
		return 2*radius*3.14;
	}
	void translate(int x, int y)
	{
		center.moveXcoord(x);
		center.moveYcoord(y);
	}
	void print()
	{
		cout<<"Center: ";
		center.printPoint();
		cout<<"Radius: "<<radius<<endl;
	}
};

class Triangle: public Shape
{
private:
	Point a,b,c;
public:
	Triangle(Point a=(0,0), Point b=(0,0), Point c=(0,0))
	{
		this->a=a;
		this->b=b;
		this->c=c;
	}
	~Triangle(){}
	void Create()
	{
		Point a;
		cout<<"Point A: ";
		a.readPoint();
		this->a=a;
		Point b;
		cout<<"Point B: ";
		b.readPoint();
		this->b=b;
		Point c;
		cout<<"Point C: ";
		c.readPoint();
		this->c=c;
	}
	float Area()
	{
		float A=b.lengthToPoint(c);
		float B=a.lengthToPoint(c);
		float C=b.lengthToPoint(a);
		float p=(A+B+C)/2;
		return sqrt(p*(p-A)*(p-B)*(p-C));
	}
	float Perimeter()
	{
		return b.lengthToPoint(a)+b.lengthToPoint(c)+a.lengthToPoint(c);
	}
	void translate(int x, int y)
	{
		a.moveXcoord(x);
		a.moveYcoord(y);
		b.moveXcoord(x);
		b.moveYcoord(y);
		c.moveXcoord(x);
		c.moveYcoord(y);
	
	}
	void print()
	{
		cout<<"Point A: ";
		a.printPoint();
		cout<<"Point B: ";
		b.printPoint();
		cout<<"Point C: ";
		c.printPoint();
	}
};

class Rectangle: public Shape //neka za pravoygylnika dadem to4ki v dolniq lqv vryh i gorniq desen vryh.
{
public:
	Point a,b;
	Rectangle(Point A=(0,0), Point B=(0,0))
	{
		a=A;
		b=B;
	}
	~Rectangle(){}
	void Create()
	{
		Point a;
		cout<<"Point A: ";
		a.readPoint();
		this->a=a;
		Point b;
		cout<<"Point B: ";
		b.readPoint();
		this->b=b;
	}
	float Area()
	{
		return (b.getXcoord()-a.getXcoord())*(b.getYcoord()-a.getYcoord());
	}
	float Perimeter()
	{
		return 2*(b.getXcoord()-a.getXcoord())+(b.getYcoord()-a.getYcoord());
	}
	void translate(int x, int y)
	{
		a.moveXcoord(x);
		a.moveYcoord(y);
		b.moveXcoord(x);
		b.moveYcoord(y);
	}
	void print()
	{
		cout<<"Point A: ";
		a.printPoint();
		cout<<"Point B: ";
		b.printPoint();
	}
};

class Square: public Rectangle //neka i za kvadratyt zadadem dve to4ki kato pravoygylnika
{
public:
	Square (Point A=(0,0), Point B=(0,0)): Rectangle (A,B)
	{
		while(a.getXcoord()-b.getXcoord()!=a.getYcoord()-b.getYcoord())
		{
			cout<<"redef Point B:";
			b.readPoint();
		}
	}
	~Square(){}
	void Create()
	{
		Point A;
		cout<<"Point A: ";
		A.readPoint();
		a=A;
		do
		{
			Point B;
			cout<<"Point B: ";
			B.readPoint();
			b=B;
		}
		while (a.getXcoord()-b.getXcoord()!=a.getYcoord()-b.getYcoord());
	}
	float Area()
	{
		return (b.getXcoord()-a.getXcoord())*(b.getXcoord()-a.getXcoord());
	}
	float Perimeter()
	{
		return 4*(b.getXcoord()-a.getXcoord());
	}
	void translate(int x, int y)
	{
		a.moveXcoord(x);
		a.moveYcoord(y);
		b.moveXcoord(x);
		b.moveYcoord(y);
	}
	void print()
	{
		cout<<"Point A: ";
		a.printPoint();
		cout<<"Point B: ";
		b.printPoint();
	}	
};

class Shapes
{
private:
	Shape** container;
	int number;
public:
	Shapes (Shape**c, int n)
	{
		container=new Shape*[n];
		for (int i=0; i<n; i++)
		{
			container[i]=c[i];
		}
		number=n;
	}
	Shapes (const Shapes&sh)
	{
		number=sh.number;
		container = new Shape*[number];
		for (int i=0; i<number; i++)
		{
			container[i]=sh.container[i];
		}
	}
	Shapes& operator = (const Shapes&sh)
	{
		if(this!=&sh)
		{
			delete[]container;
			number=sh.number;
			container = new Shape*[number];
			for (int i=0; i<number; i++)
			{
				container[i]=sh.container[i];
			}
		}
		return *this;
	}
	~Shapes()
	{
		delete[]container;
	}
	void AddShape() //neka dobavqme samo edna figura
	{
		Shape *sh;
		int n;
		cout<<"Circle = 1\nRectangle=2\nTriangle=3\nSquare=4";
		cin>>n;
		switch(n)
		{
		case 1: sh=new Circle;
		case 2: sh=new Rectangle;
		case 3: sh=new Triangle;
		case 4: sh=new Square;
		}
		sh->Create();
		number++;
		Shape** tempShape=new Shape*[number+1];
		for (int i=0; i<number; i++)
		{
			tempShape[i]=container[i];
		}
		tempShape[number]=sh;
		Shape* oldShape=*container; //tuk e greshno, triabva "oldShape = container; for (int i=0;i<number;i++) delete oldShape[i]; delete [] oldShape;" inache triesh samo purvia element kakto si go napravil
		container=tempShape;
		delete oldShape;
	}
	void printShape(int number)
	{
		container[number-1]->print();
	}
	void calculateAllArea()
	{
		float allSurface=0;
		for (int i=0; i<number; i++)
				allSurface+=container[i]->Area();
		cout<<"Area of all shapes: "<<allSurface;
	}
};
void main()
{}