#include <iostream>
using namespace std;

template <class X> class Sequence {
	X *a;
	int s;
public:
	Sequence() //konstruktor po podrazbirane
	{
		a = new X; //Joro: a triabva da e NULL tuk, v momenta ima edin element, a size e 0
		s = 0;
	}
	Sequence(int sz) // konstruktor s parametyr za razmer
	{
		s=sz;
		a = new X[s];		
	}
	~Sequence() //destruktor
	{
		delete a;
	}
	Sequence(Sequence<X> &b)//konstruktor za kopirane
	{
		//Joro: a triabva da se zadeli s new X[s]!
		for (int i=0; i < b.s; i++)
			a[i] = b.a[i];
		s = b.s;
	}
	Sequence & operator=(Sequence<X> &b) // predefinirane na operator za prisvoqvane
	{
		//Joro: sushtoto kato gore; osven tova triabva proverka if (this != &b)
		for (int i=0; i < b.s; i++)
			a[i] = b.a[i];
		s = b.s;
		return this; //Joro: triabva return *this
	}
	void set_elem(X el, int p) // funkciq za promqna na p-tiq element ot reda
	{
		a[p]=el;
	}
	void output() // funkciq za izvejdane na redicata na edin red
	{
		for (int i=0; i < s; i++)
			cout << a[i];
	}
	int operator<(Sequence<X> &b) // operator za leksikografsko sravnqvane
	{							//vrushta -1 ako leviq elemetn e po-golqm
		int temp;				// 0 ako sa ravni i 1 ako desniq e po-golqm
		if (s < b.s)
			temp = s;
		else
			temp = b.s;
		for (int i=0; i < temp; i++) //Joro: komentari po-dolu
			if (a[i]<b.a[i]) return 1; //tuk triabva da vrushta -1
			else if (a[i]>b.a[i]) return -1; //a tuk 1
			return 0; //tova ne e viarno - tuk triabva edna proverka za razmera na sequencite
	}
	Sequence *operator+(Sequence<X> &b)//operator za konkatenirane, koito vrushta
	{									//ukazatel kym nova redica, koqto e subranite stari
		Sequence *n = new Sequence; 
		n->a = new X[s+b.s];
		n->s = s + b.s;
		for (int i=0; i < s; i++)
			n->set_elem(a[i],i);
		for (int i=0; i < b.s; i++)
			n->set_elem(b.a[i],s+i);
		return n; //Joro: ne triabva da vrushtash neshta, zadeleni s new!!! zashto vrushtash ukazatel, a ne cial obekt??
	}
	int subsearch(Sequence<X> &b)//funkciq za tursene na podredica. Ako razmera na parametura e po-golqm ot tozi na 
								//redicata v koqto se tursi, funkciqta vru6ta -2
	{                           // pri nali4ieto na 2 podredici funkciqta vru6ta indeksa na purvata sre6tnata
		bool isThere;	
		if (b.s > s) 
		{
			cout << "Parameter's size larger than sequence's one!";
			return -2;
		}
		for (int i=0; i < s; i++) //Joro: mojesh do s-b.s, natatuk e iasno che ne moje da bude, tui kato ne dostigat simvoli
		{
			isThere = true;
			for (int j=0; j < b.s; j++)
				if (a[i+j] != b.a[j])
					isThere = isThere && false; //Joro: ??? tova e vse edno prosto isThere = false; triabva da ima i break osven tova
			if (isThere) return i;
		}
		return -1;
	}
};

class BadTest //klasut e abstrakten s edna 4ista virtualna funkciq
{
	virtual void alabala() = 0 ;
};


void main()
{
	int res,func;

	Sequence<char> intA(3); 
	Sequence<char> intB(3);
	Sequence<char> test(2);
	Sequence<BadTest> s; // ako tozi red se izkomentira celiq, koda se kompilira

	intA.set_elem('a',0);
	intA.set_elem('b',1);
	intA.set_elem('c',2);

	intB.set_elem('a',0);
	intB.set_elem('b',1);
	intB.set_elem('d',2);

	test.set_elem('b',0);
	test.set_elem('d',1);

	res = intA<intB;
	cout << res <<endl;

	Sequence<char> *newSeq;

	newSeq=intA+intB;

	newSeq->output();
    cout << endl;

	func = newSeq->subsearch(test);
	cout << func;
}

//Joro: Niamash pratena vtora zadacha?