#include<iostream>
using namespace std;

template<class T>
class Bag{
protected:
	static const int EXTEND=100;
	int n;
	T** arr;
	void copy_own(const Bag& b);
public:
	Bag(int=100);
	Bag(const Bag&);
	Bag<T>& operator=(const Bag&);
	~Bag();
	bool operator-=(T&);
	Bag<T>* operator|(const Bag&);
	Bag<T>* operator/(const Bag&);
};
template<class T>
Bag<T>::Bag(int n){
	this->n=n;
	arr = new T*[n];
	for(int i=0;i<n;i++)
		arr[i]=NULL;
}
template<class T>
void Bag<T>::copy_own(const Bag& b){
	n=b.n;
	arr=new T*[n];
	for(int i=0;i<n;i++)
		arr[i] = new T(b.arr[i]);
}
template<class T>
Bag<T>::Bag(const Bag& b){
	copy_own(b);
}
template<class T>
Bag<T>& Bag<T>::operator=(const Bag& b){
	delete arr;
	copy_own(b);
}
template<class T>
bool Bag<T>::operator-=(T& el){
	for(int i=0;i<n;i++)
		if(arr[i] && *(arr[i])==el){
			delete arr[i];
			return true;
		}
	return false;
}
template<class T>
Bag<T>* Bag<T>::operator|(const Bag& b){
	Bag* res = new Bag(n+b.n);
	for(int i=0;i<n;i++)
		if(arr[i]) res.arr[i]=new T(*(arr[i]));
	for(int i=0;i<b.n;i++)
		if(b.arr[i]) res.arr[i+n]=new T(*(b.arr[i]));
	return res;
}
template<class T>
Bag<T>* Bag<T>::operator/(const Bag& b){
	bool* tmp=new bool[n];
	for(int i=0;i<n;i++)
		for(int j=0;j<b.n;j++)
			if(*arr[i]==*b.arr[j])
				tmp[i]=false;
	
	Bag* res=new Bag(n);
	for(int i=0;i<n;i++)
		if(!tmp[i])
			res.arr[i]=new T(*arr[i]);
	return res;
}
template<class T>
Bag<T>::~Bag(){
	for(int i=0;i<n;i++)
		if(arr[i]) delete arr[i];
	delete arr;
}



template<class T>
class Set: public Bag<T>{
	void duplicates();
protected:
	void copy_own(const Set&);
public:
	Set(int n=100);
	Set(const Set&);
	~Set();
	Set<T>& operator=(const Set&);
	Set(const Bag& b):Bag(b){ duplicates(); }
	bool operator-=(T&);
	Set<T>* operator|(const Set&);
	Set<T>* operator/(const Set&);
};
template<class T>
void Set<T>::duplicates(){
	for(int i=0;i<n-1;i++)
		for(int j=i+1;j<n;j++)
			if(arr[j] && *arr[i]==*arr[j]){
				delete arr[j];
				arr[j]=NULL;
			}
}
template<class T>
Set<T>::Set(int n):Bag(n){ }

template<class T>
Set<T>::Set(const Set& s):Bag(s){ duplicates();}

template<class T>
Set<T>& Set<T>::operator=(const Set& s){
	Bag::operator=(s);
}

template<class T>
Set<T>* Set<T>::operator|(const Set& s){
	Set* res = new Set(*Bag::operator|(s));
	res->duplicates();
	return res;
}
template<class T>
Set<T>* Set<T>::operator/(const Set& s){
	Set* res = new Set(*Bag::operator/(s));
	res->duplicates();
	return res;
}
template<class T>
bool Set<T>::operator-=(T& el){
	return Bag::operator-=(el);
}
template<class T>
Set<T>::~Set(){}

int main(){
	Set<int> s;
}