#include<iostream>
#include<math.h>
#include<fstream>
using namespace std;

struct Point{
	double x,y;
	void print(ostream& stream =cout){
		stream<<'('<<x<<','<<y<<')'<<'\n';
	}
};

class Parallelogram{
protected:
	double a,b, hA, hB, alpha;
	Point ps[4];
public:
	double Area(){
		return a*b*alpha;
	}
	double Perimeter(){
		double res=0;
		for(int i=0;i<4;i++)
			res+= sqrt( (ps[i].x-ps[(i+1)%4].x)*(ps[i].x-ps[(i+1)%4].x)
						+ (ps[i].y-ps[(i+1)%4].y)*(ps[i].y-ps[(i+1)%4].y) );
		return res;
	}
	void translate(int x, int y){
		for(int i=0;i<4;i++){
			ps[i].x += x;
			ps[i].y += y;
		}
	}
	void setA(double a){this->a=a;}
	void setB(double b){this->b=b;}
	void setHa(double h){this->hA=h;}
	void setHb(double h){this->hB=h;}
	void setAlpha(double a){if(a>1 || a<0) this->alpha= 1/fabs(a); else alpha=a;} //tova zashto e? alpha e ugul, ne cos/sin
	double getA()const{return a;}
	double getB()const{return b;}
	double getHa()const{return hA;}
	double getHb()const{return hB;}
	double getAlpha()const{return alpha;}

	virtual void print(ostream& stream=cout)=0;
};


//ideiata na dolnite klasove e da ogranichavat nepravilnite setteri taka che da poddurjat obektite si v konsistentno sustoianie
//napr. setB za kvadrat ne triabva da zadava stoinost razlichna ot tazi na a i t.n.


class Diamond: virtual public Parallelogram{
public:
	Diamond(Point*);
	void print(ostream& =cout);
};
Diamond::Diamond(Point* p){
	for(int i=0;i<4;i++)
		ps[i]=p[i];
}
void Diamond::print(ostream& stream){
	stream << "Diamond: ";
	for(int i=0;i<4;i++)
		ps[i].print();
	
	stream << "a: "<< a<< '\n';
	stream << "b: "<< b<< '\n';
	stream << "hA: "<< hA<< '\n';
	stream << "hB: "<< hB<< '\n';
	stream << "alpha: "<< alpha<< '\n';
}
//
class Rectangle: virtual public Parallelogram{
public:
	Rectangle(Point*);
	void print(ostream& =cout);
};
void Rectangle::print(ostream& stream){
	stream << "Rectangle: ";
	for(int i=0;i<4;i++)
		ps[i].print(stream);
	
	stream << "a: "<< a<< '\n';
	stream << "b: "<< b<< '\n';
	stream << "hA: "<< hA<< '\n';
	stream << "hB: "<< hB<< '\n';
	stream << "alpha: "<< alpha<< '\n';
}
Rectangle::Rectangle(Point* p){
	for(int i=0;i<4;i++)
		ps[i]=p[i];
}
//
class Square: virtual public Parallelogram{
public:
	Square(Point*);
	void print(ostream& =cout);
};
Square::Square(Point* p){
	for(int i=0;i<4;i++)
		ps[i]=p[i];
}
void Square::print(ostream& stream){
	stream << "Square: ";
	for(int i=0;i<4;i++)
		ps[i].print();
	
	stream << "a: "<< a<< '\n';
	stream << "b: "<< b<< '\n';
	stream << "hA: "<< hA<< '\n';
	stream << "hB: "<< hB<< '\n';
	stream << "alpha: "<< alpha<< '\n';
}

class Shapes{
	const static int N=100;
	Parallelogram* p[N];
public:
	void printShape(int n){ p[n]->print();}
	void translateAll(int x, int y){
		for(int i=0;i<N;i++)
			p[i]->translate(x,y);
	}
	void SaveToFile(char* filename){
		ofstream s(filename, ios::out);
		for(int i=0;i<N;i++)
			p[i]->print(s);
	}
};