//Anna Delcheva, gr 6, f.n.44553
#include<iostream>
#include <fstream>
using namespace std;
template<class T>
class sequence
{
public:
	sequence(int k=0);
	~sequence();
	sequence(const sequence<T>& other);
	sequence<T>& operator=(const sequence<T>& other);
	bool operator< (const sequence<T>& other);
	sequence<T> operator+ (const sequence<T>& other1);
	void Enter()
	{
		for(int i=0,i<n,i++)
		{
			cout<<i<<":";
			cin<<elem[i];
		}
	}
private:
	T* elem;
	int n;

};
template<class T>
sequence<T>::sequence(int k)
{
	elem=new T[k];
	for(int i =0;i<k;i++)
	{
		elem[i]=0;
	}
	n=k;
}
template<class T>
sequence<T>::~sequence()
{
	delete[] elem;
}
template<class T>
sequence<T>::sequence(const sequence& other)
{
	elem=new T[other.n];
	n=other.n;
	for(int i=0;i<other.n;i++)
	{
		elem[i]=other.elem[i];
	}
}
template<class T>
sequence<T>& sequence<T>::operator =(const sequence<T> &other)
{
	if(this != &other)
	{
		delete[]elem;
		elem=new T[other.n];
		n=other.n;
		for(int i=0;i<other.n;i++)
		{
			elem[i]=other.elem[i];
		}
	}
	return *this;
}
template<class T>
bool sequence<T>::operator <(const sequence<T>& other)
{
  if( n<other.n) return true; //tova ne e viarno za leksikografsko sortirane, napr. "abc" < "ba"
  if( n>other.n) return false; //sushto
  for(int i =0;i<n;i++)
  {
	  if(elem[i]>other.elem[i]) return false;
  }
  else return true; //triabva purvo da se izvurshi gornia cikul i chak posle, ako ediniat e po-dulug, drugiat da e po-malkiat
}
template<class T>
sequence<T> sequence<T>::operator +(const sequence<T> &other) //tazi implementacia ne e viarna, vse pak ima primer v uslovieto: [3 1]+[5 6]=[3 1 5 6], a ne [8 7]
{
	if(this->n != other.n) return false; 

	squence<T> temp;
	temp= new T[other.n];
	temp.n=other.n;

	for(int i=0;i<other.n;i++)
	{
		temp.elem[i]=this->elem[i]+other.elem[i];
	}
	return temp;
}
int main()
{
	sequence<int> G(5);

	return 0;
}

class operations
{
public:
 virtual operations& add(const operations&); 
 virtual operations& scale(double );
 virtual double _dim() const;
 virtual double f(double) const;
 virtual void print_safe() const;
};
class Vector:public operations
{
private:
 double* V;
 int dim;
public:
 void Set(int =0);
 void initiate();
 Vector(int =0);
 Vector(const Vector&);
 ~Vector(){delete []V;};
 Vector& operator=(const Vector&);
 Vector& add(const Vector&);
 Vector& scale(double);
 double f(double)const;
 double _dim() const {return dim;};
 void print_safe()const;
};
void Vector::Set(int a)
{
 V=new double[a];
 dim=a;
}
Vector::Vector(int a)
{ 
 Set(a);
 dim=a; //tova go ima v set
}
Vector::Vector(const Vector& other)
{
 Set(other.dim);
 for(int i=0;i<dim;i++)
  V[i]=other.V[i];
 
}
Vector& Vector::operator=(const Vector& other)
{
 if(this!=&other)
 { 
  delete []V;
  dim=other.dim;
  V=new double [dim];
  for(int i=0;i<dim;i++)
   V[i]=other.V[i];
 }
 return*this;
}
void Vector::initiate()
{
 for(int i=0;i<dim;i++)
 { 
  cout<<"a"<<i<<"=";cin>>V[i];
 }
}
Vector& Vector::add(const Vector &other) //triabva da se vrushta nov vektor
{ 
 for(int i=0;i<min(dim,other.dim);i++) //ne, triabva da se pravi subirane samo ako dim = other.dim
 {
  V[i]+=other.V[i];
 }
 if(dim<other.dim) *this=other; // ???????????
 return *this;
}
Vector& Vector::scale(double a) //i tuk - nov vektor
{ 
 for(int i=0;i<dim;i++)
 {
  V[i]*=a;
 }
 return *this;
}
double Vector::f(double a) const
{
 int b=a;
 if (b>dim) return -1;
 return V[b];
}
void Vector::print_safe()const
{
 ofstream fout("Vector.dat",ios::app); //triabva #include <fstream>
 cout<<"(";
 fout<<"(";
 for(int i=0;i<dim;i++)
 {
  cout<<V[i]<<",";
  fout<<V[i]<<",";
 }
 cout<<")\n";
 fout<<")\n";
 fout.close();
}
class Polynome:public operations
{
private: 
 double* coefs;
 int deg;
public:
 void initiate();
 Polynome(int =0);
 Polynome(const Polynome&);
 ~Polynome(){delete []coefs;};
 Polynome& operator=(const Polynome&);
 Polynome& add(const Polynome&);
 Polynome& scale(double);
 double f(double)const;
 double _dim() const {return deg;};
 void print_safe()const;
};
Polynome::Polynome(int a)
{
 coefs=new double [a];
 deg=a;
}
Polynome::Polynome(const Polynome& other)
{
 deg=other.deg;
 coefs=new double[deg];
 for(int i=0;i<deg;i++)
 {
  coefs[i]=other.coefs[i];
 }
}
Polynome& Polynome::operator=(const Polynome& other)
{
 if (this!=&other){
  delete []coefs;
  deg=other.deg;
  coefs=new double[deg];
  for(int i=0;i<deg;i++)
  {
   coefs[i]=other.coefs[i];
  }
 } //triabva return *this;
}