#include <iostream>
#include<math.h>
using namespace std;

class Point
{
	float x;
	float y;
public:
	Point(float a=0.0,float b=0.0){x=a; y=b;}
	void setX(float a){x=a;}
	void setY(float b){y=b;}
	float getX()const{return x;}
	float getY()const{return y;}
	Point& operator=(const Point& p) //niama nujda ot operator = za takuv klas bez dinamichni danni, toi se suzdava ot kompilatora
	{if(this==&p)
	return *this;
		x=p.getX();
		y=p.getY();
		return *this;
	}
};


float lineLength (const Point&p1, const Point& p2)
{
	return sqrt( ((p2.getX()-p1.getX())*(p2.getX()-p1.getX()))   +   ((p2.getY()-p1.getY())*(p2.getY()-p1.getY())) );
}

class Parallelogram
{
public:
	virtual void print()=0;
	virtual void translate(int x, int y)=0;
	virtual float Perimeter()=0;
	virtual float Area()=0;

	virtual float getA()const=0;
	virtual float getB()const=0;
	virtual void setA(float a1)=0;
	virtual void setB(float b1)=0;

	virtual float getHa()const=0;
	virtual float getHb()const=0;
	virtual void setHa(float ha1)=0;
	virtual void setHb(float hb1)=0;

	virtual int getAngle()const =0;
	virtual void setAngle(int an)=0;

	virtual void setArray(Point& p1, Point& p2)=0;
	virtual Point* getArray()=0; 
};

class Square : public Parallelogram
{
	Point* points;
	float a; float b;
	float ha; float hb;
	static const int angle=90;
public:
Square()
{
	a=0;
	b=0;
	ha=0;
	hb=0;
	points=NULL;
}
~Square()
{
	delete[]points;
	a=0; //niama smisul da gi priravniavash na nula
	b=0;
	ha=0;
	hb=0;
}
Square(const Square& r)
{
	a=r.getA();
	b=r.getB();
	ha=r.getHa();
	hb=r.getHb();
	points[0]=r.points[0]; //points triabva da e zadelen!
	points[1]=r.points[1];
}
Square& operator= (const Square& r)
{
	if (this==&r)
		return *this;
	a=r.getA();
	b=r.getB();
	ha=r.getHa();
	hb=r.getHb();
	delete[]points;
	points[0]=r.points[0]; //points triabva da se zadeli na novo predi da moje da se polzva pak
	points[1]=r.points[1];
	return *this;
}
	void print()
	{
		cout <<"Line 1:"<<a<<endl;
		cout <<"Line 2:"<<b<<endl;
		cout <<"Height 1:"<<ha<<endl;
		cout <<"Height 2:"<<hb<<endl;
		cout<<"Angle:"<<angle<<endl;
	};
	void translate(int x1, int y1)
	{
		for (int i=0; i<2; i++)
		{
			points[i].setX(points[i].getX()+x1);
			points[i].setY(points[i].getY()+y1);
		}
	}
	float Perimeter(){return a*4;}
	float Area(){return a*a;}
	float getA()const{return a;}
	float getB()const{return b;}
	void setA(float a1){a=a1; b=a1; ha=a1; hb=a1;} //tezi dvete za da se zapazi kvadrata
	void setB(float b1){b=b1; a=b; ha=b; hb=b;} // ^^^^^
	float getHa()const{return ha;}
	float getHb()const{return hb;}
	void setHa(float ha1){ha=ha1; hb=ha1;}
	void setHb(float hb1){hb=hb1; ha=hb1;}
	int getAngle()const{return 90;}
	void setAngle(int an){cout<<"Unable to change the square's angle";}
	void setArray(Point& p1, Point& p2){points[0]=p1; points[1]=p2;}
	Point* getArray(){return points;}
};

class Rectangle : public Parallelogram //zabelejkite ot gore vajat i za tuk. osven tova naslediavaneto triabva da e virtual
{
	Point* points;
	float a; float b;
	float ha; float hb;
	static const int angle=90;
public:
Rectangle()
{
	a=0;
	b=0;
	ha=0;
	hb=0;
	points=NULL;
}
~Rectangle()
{
	delete[]points;
	a=0;
	b=0;
	ha=0;
	hb=0;
}
Rectangle(const Rectangle& r)
{
	a=r.getA();
	b=r.getB();
	ha=r.getHa();
	hb=r.getHb();
	points[0]=r.points[0];
	points[1]=r.points[1];
}
Rectangle& operator= (const Rectangle& r)
{
	if (this==&r)
		return *this;
	a=r.getA();
	b=r.getB();
	ha=r.getHa();
	hb=r.getHb();
	delete[]points;
	points[0]=r.points[0];
	points[1]=r.points[1];
	return *this;
}
	void print()
	{
		cout <<"Line 1:"<<a<<endl;
		cout <<"Line 2:"<<b<<endl;
		cout <<"Height 1:"<<ha<<endl;
		cout <<"Height 2:"<<hb<<endl;
		cout<<"Angle:"<<angle<<endl;
	};
	void translate(int x1, int y1)
	{
		for (int i=0; i<2; i++)
		{
			points[i].setX(points[i].getX()+x1);
			points[i].setY(points[i].getY()+y1);
		}
	}
	float Perimeter(){return a*2+b*2;}
	float Area(){return a*b;}
	float getA()const{return a;}
	float getB()const{return b;}
	void setA(float a1){a=a1;}
	void setB(float b1){b=b1;}
	float getHa()const{return ha;}
	float getHb()const{return hb;}
	void setHa(float ha1){ha=ha1; a=ha1;}
	void setHb(float hb1){hb=hb1; b=hb1;}
	int getAngle()const{return 90;}
	void setAngle(int an){cout<<"Unable to change the rectangle's angle";}
	void setArray(Point& p1, Point& p2){points[0]=p1; points[1]=p2;}
	Point* getArray(){return points;}
};

class Diamond : public Parallelogram
{
	Point* points;
	float a; float b;
	float ha; float hb;
	int angle;
public:
Diamond()
{
	a=0;
	b=0;
	ha=0;
	hb=0;
	points=NULL;
}
~Diamond()
{
	delete[]points;
	a=0;
	b=0;
	ha=0;
	hb=0;
}
Diamond(const Diamond& d)
{
	a=d.getA();
	b=d.getB();
	ha=d.getHa();
	hb=d.getHb();
	points[0]=d.points[0];
	points[1]=d.points[1];
}
Diamond& operator= (const Diamond& r)
{
	if (this==&r)
		return *this;
	a=r.getA();
	b=r.getB();
	ha=r.getHa();
	hb=r.getHb();
	delete[]points;
	points[0]=r.points[0];
	points[1]=r.points[1];
	return *this;
}
	void print()
	{
		cout <<"Line 1:"<<a<<endl;
		cout <<"Line 2:"<<b<<endl;
		cout <<"Height 1:"<<ha<<endl;
		cout <<"Height 2:"<<hb<<endl;
		cout<<"Angle:"<<angle<<endl;
	};
	void translate(int x1, int y1)
	{
		for (int i=0; i<2; i++)
		{
			points[i].setX(points[i].getX()+x1);
			points[i].setY(points[i].getY()+y1);
		}
	}
	float Perimeter(){return a*4;}
	float Area(){return a*ha;}
	float getA()const{return a;}
	float getB()const{return b;}
	void setA(float a1){a=a1; b=a1;}
	void setB(float b1){b=b1; a=b1;}
	float getHa()const{return ha;}
	float getHb()const{return hb;}
	void setHa(float ha1){ha=ha1;}
	void setHb(float hb1){hb=hb1;}
	int getAngle()const{return angle;}
	void setAngle(int an){angle=an;}
	void setArray(Point& p1, Point& p2){points[0]=p1; points[1]=p2;}
	Point* getArray(){return points;}
};

class Shapes
{
Parallelogram* array[1000];
int currentSize;
public:
	int getCurrentSize(){return currentSize;}
	void AddShape() //principno novite formi triabva da se inicializirat, a ne da sa s default constructor samo
	{
			char sh;
		cout<<"what shape do you want? :";
		cin>>sh;
		if (currentSize>=1000)
		{
		cout<< "cant' add more shapes!";
		return;
		}
		switch (sh)
		{
		case 's':
			{
			Square* temp=new Square();
			array[currentSize]=temp;
			currentSize++;
			}
		case'r':
			{
			Rectangle* temp=new Rectangle();
			array[currentSize]=temp;
			currentSize++;
			}
		case'd':
			{
			Diamond* temp=new Diamond();
			array[currentSize]=temp;
			currentSize++;
			}
		}
	}

	void printShape(int i)
	{
		array[i]->print();
	}
	void translateAll(int x1, int y1)
	{
		for (int i=0; i< currentSize; i++)
		{
			array[i]->translate(x1,y1);
		}
	}
};