#include <iostream>
#include <string.h>
#include <math.h>
using namespace std;

template <class T>
class Bag
{
	T* elements;
	int maxSize;
	int currentSize;
public:
	int getMaxSize()const{return maxSize;}
	void setMaxSize(int a){maxSize=a;}
	int getcurrentSize()const{return currentSize;}
	T& getElement(int i){return elements[i];}
	Bag(int k)
	{
		elements=NULL;
		maxSize=k;
		currentSize=0;
	}
	~Bag()
	{
		delete [] elements;
		maxSize=0;
		currentSize=0;
	}
	Bag(const Bag& b)
	{
		//tova e copy constructor => elements ne e inicializiran, triabva da se zadeli s new
		maxSize=b.getMaxSize();
		currentSize=b.getcurrentSize();
		for (int i=0; i<currentSize; i++)
			elements[i]=b.getElement(i);
	}
	Bag& operator =(const Bag& b)
	{
		if (this==&b)
			return *this;
		delete [] elements //i tuk triabva da se zadeli s new
		maxSize=b.getMaxSize();
		currentSize=b.getcurrentSize();
		for (int i=0; i<currentSize; i++)
			elements[i]=b.getElement(i);
		return *this;
	}

	void addElement(const T& el)
	{
		if (currentSize < maxSize)
		{
			elements[currentSize]=el;
			currentSize++;
		}
		else
		{
			Bag* temp=new Bag(maxSize);
			for (int i=0; i<currentSize; i++)
			{
				temp->addElement(elements[i]); //niama nujda da se suzdava nov Bag, tova e izlishno uslojniavane
			}
			delete[]elements;
			maxSize+=20;
			for(int j=0; j< currentSize; j++)
				elements[j]=temp->getElement(j); //ne moje taka, elements e iztrit. triabva da go zadelish nanovo
			delete temp; 
		}
	}
	bool operator-= (const T& el)
	{
		for (int i=0; i< currentSize; i++)
		{
			if (elements[i]==el)
				delete elements[i]; //elements[i] ne e ukazatel, ne mojesh da go triesh
			return true;
		}
		return false;
	}

	Bag& operator | (const Bag& b)  //tuk triabva da se vurne nov obekt, a ne psevdonim
	{int n=b.getMaxSize()+ maxSize; //niama nujda ot b.getMaxSize(), dostatuchno e b.maxSize
		Bag temp= new Bag(n); //new vrushta ukazatel, t.e. temp e Bag*

		for(int i=0; i<b.getCurrentSize(); i++)
			temp.addElement(b.getElement(i));
		for (int j=0; j<currentSize; j++)
			temp.addElement(elements[j]);
		return temp;
	}
	Bag& operator / (const Bag& b)
	{Bag temp= new Bag(maxSize);
	//..... ?
	}
};

template <class T>
class Set : public Bag
{
    public:
    	Set(int k) 
	{
		elements=NULL;
		maxSize=k;
		currentSize=0;
	}
	~Set()  //tezi neshta se naslediavat ot Bag
	{
		delete [] elements;
		maxSize=0;
		currentSize=0;
	}
	Set(const Bag& b) //i tova moje da se nasledi i samo da se vika tuk, da ne govorim che povtariash sushtite greshki
	{
		maxSize=b.getMaxSize();
		currentSize=b.getcurrentSize();
		for (int i=0; i<currentSize; i++)
			elements[i]=b.getElement(i);
	}
	Set& operator =(const Set& b)
	{
		if (this==&b)
			return *this;
		delete [] elements
		maxSize=b.getMaxSize();
		currentSize=b.getcurrentSize();
		for (int i=0; i<currentSize; i++)
			elements[i]=b.getElement(i);
		return *this;
	}

	void addElement(const T& el)
	{
		if (currentSize < maxSize)
		{
		    for (int i=0; i< currentSize; i++)
		    {
		        if (elements[i]==el)
		        {
		            return
		        }
		        else
		        {
                    elements[currentSize]=el;
                    currentSize++;
                }
		    }
		}
		else
		{
			Bag* temp=new Bag(maxSize); //tuk triabva Set, ne Bag. greshkite sa kato gore
			for (int i=0; i<currentSize; i++)
			{
				temp->addElement(elements[i]);
			}
			delete[]elements;
			maxSize+=20;
			for(int j=0; j< currentSize; j++)
				elements[j]=temp->getElement(j);
			delete temp;
		}
	}
};

int main()
{
int a=5;
 Bag<int> bb=new Bag<int>(5);
 Bag<int> b2= new Bag<int>(9);
 b2.addElement(a);
 b2-=a;
 Bag<int> test=new Bag<int>(bb|b2);
}





