// SVETLIN ZAMFIROV 44605
#include <iostream>

using namespace std;

const int SIZE=50;

int length(const char* p){ //strlen
    const char *s;
    for (s = p; *s; ++s);
    return(s - p);
}

class EatingCreature{
protected:
	double weight;
	double km;
	char* name;
public:
	EatingCreature(){
		weight=0;
		km=0;
		name=0;
	}
	EatingCreature(double w,double k,char* n){
		weight=w;
		km=k;
		name=new char[length(n)+1];
		strcpy(name,n);
	}
	EatingCreature(const EatingCreature& e){
		weight=e.weight;
		km=e.km;
		name=new char[length(e.name)+1];
		strcpy(name,e.name);
	}
	~EatingCreature(){delete [] name;}
	EatingCreature& operator=(const EatingCreature& e){
		if(this!=&e){
			weight=e.weight;
			km=e.km;
			name=new char[length(e.name)+1];
			strcpy(name,e.name);
		}
		return *this;
	}
	virtual double EnergyPerDay()=0;
	virtual double FoodPerDay()=0;
	virtual double Distance()=0; //tazi funkcia triabva da vzima parametur hrana i da vrushta kilometrite koito mogat da se izminat s tazi hrana
	virtual void print()=0;
};

class Dog:public EatingCreature{
public:
	virtual double EnergyPerDay(){
		return this->weight*this->km;
	}
	virtual double FoodPerDay(){
		return 2*this->EnergyPerDay();
	}
	virtual double Distance(){ //vij gore
		return FoodPerDay()/2*weight; //weight sushto triabva da e v znamenatel, triabvat skobi; ne ni triabva foodperday(), a parametur
	}
	virtual void print(){
		cout<<name<<endl;
		cout<<weight<<endl;
		cout<<km<<endl;
	}
};

class American:public EatingCreature{
private:
	int McDon;
public:
	American(){
		McDon=0;
	}
	American(char* n,double w,double k,int m):EatingCreature(w,k,n){
		McDon=m;
	}
	American(const American& a){ //triabva da vikash EatingCreature(a), vij po-podrobno dolu
		McDon=a.McDon;
	}
	American& operator=(const American& a){ 
		if(this!=&a){
			McDon=a.McDon;
		}
		return *this;
	}
	virtual double EnergyPerDay(){
		return km*weight/10;
	}
	virtual double FoodPerDay(){
		double e=km*weight/10;
		for(int i=0;i<McDon;i++){
			e=e+e/5;
		}
		return e;
	}
	virtual double Distance(){
		return FoodPerDay()/2*weight; //ne e viarno
	}
	virtual void print(){
		cout<<name<<endl;
		cout<<weight<<endl;
		cout<<km<<endl;
		cout<<McDon<<endl;
	}
};

class Woman:public EatingCreature{
private:
	int age;
	int nervous;
public:
	Woman(){
		age=0;
		nervous=0;
	}
	Woman(char* n,double w,double k,int a,int ne):EatingCreature(w,k,n){
		age=a;
		if(ne>0&&ne<4) nervous=ne; //a v protiven sluchai? triabva vinagi da inicializirash, dori s 0
	}
	Woman(const Woman& w){ //niama nujda ot cctor i operator = za klasove bez dinamichni danni, v sluchaia EatingCreature se opravia
		//a ti sled kato napishesh tozi constructor i ne vikash :EatingCreature(w) vsushtnost ne inicializirash name, km, weight
		age=w.age;
		nervous=w.nervous;
	}
	Woman& operator=(const Woman& w){ //sushtoto kato gore. triabva da inicializrash vsichki danni
		if(this!=&w){
			age=w.age;
			nervous=w.nervous;
		}
		return *this;
	}
	virtual double EnergyPerDay(){
		return (weight*km)*nervous;
	}
	virtual double FoodPerDay(){
		double e=EnergyPerDay();
		if(age<12) return e;
		if(age>11&&age<43) return e/2;
		return e+3*e/20;
	}
	virtual double Distance(){
		return FoodPerDay()/2*weight; //i tuk ne e taka
	}
	virtual void print(){
		cout<<name<<endl;
		cout<<weight<<endl;
		cout<<km<<endl;
		cout<<age<<endl;
		cout<<nervous<<endl;
	}
};

void Func(EatingCreature* e,double food){
	EatingCreature* tmp;
	*tmp=e[0];
	for(int i=0;i<SIZE;i++){
		if(e[i].FoodPerDay()==food) //ne e taja logikata, distance triabva da priema parametura food
			if((*tmp).Distance()>e[i].Distance()) e[i].print(); //taka ne printirash maksimalnoto, a printirash vsichki s po-goliam distance ot purvia
			else (*tmp).print();
	}
}

int main(){
	EatingCreature *p;
	Woman w("asd",42,5,22,2);
	w.Distance();
	w.print();
	cout<<w.EnergyPerDay()<<endl;
	cout<<w.FoodPerDay()<<endl;
	American a("ererui",83,9,4);
	//p triabva da se zadeli s new za da go polzvash kato masiv, inache pishesh v nerazreshena pamet
	p[0]=&w; //p[0] e ot tip EatingCreature, a ti mu prisvoiavash EatingCreature*
	p[1]=&a;
	Func(p,210);
	return 0;
}