// 1zada4a i 2zada4a Mihail Jekov 44516.cpp : Defines the entry point for the console application.
//

//Mihail Jekov 44516 grupa 6   1 i 2 zada4a v edno

//Ima malko gre6ki no niamam vreme za debugvane za sujalenie

#include "stdafx.h"
#include <iostream>
using namespace std;

template<class M>
class Sequence
{
public:
	Sequence();
    Sequence(unsigned=0);
    Sequence(const Sequence<M> &);
    Sequence & operator=(const Sequence<M> &);
    ~Sequence();
	Sequence operator+(const Sequence<M> &) const;
	bool operator<(const Sequence<M> &) const;
	int subsearch(const Sequence<M> &) const;
	void AllocateMemory(unsigned);
	void FreeMemory();
private:
    M *arr;
    unsigned length;
    unsigned max;
};

template <class M>
Sequence<M>::Sequence()
{
	length = max = 0; arr = NULL;
}

template <class M>
Sequence<M>::Sequence(unsigned i) {
	AllocateMemory(i);
}

template <class M>
Sequence<M>::Sequence(const Sequence<M> &n) {
	AllocateMemory(n.max);
	length = n.length;
	for(int i=0;i<length;i++) {
        arr[i] = n.arr[i];
	}
}

template <class M>
Sequence<M> & Sequence<M>::operator=(const Sequence<M> &n) {
	if((*this)==n) return *this;
	FreeMemory();
	AllocateMemory(n.max);
	for(int i=0;i<length;i++) {
        arr[i] = n.arr[i];
	}
	return *this;
}

template <class M>
Sequence<M>::~Sequence() {
    delete [] arr;
}

template <class M>
bool Sequence<M>::operator<(const Sequence<M> &n) const {
	int shorter;
	if(length>n.length) shorter = n.length;
	else shorter=length;
	for(int i=0; i<shorter; i++) {
		if(arr[i]==n.arr[i]) continue;
		else if (arr[i]<n.arr[i]) return true;
		else return false;
	}
	if(shorter==length) return true;
	return false;
}

template <class M>
Sequence<M> Sequence<M>::operator+(const Sequence<M> &n) const {
    Sequence newone(max + n.max);
	int i=0, current = 0;
	for(i; i<length; i++) {
		newone.arr[i] = arr[i];
	}
	for(i+1; i<length+n.length; i++) {
		newone.arr[i] = n.arr[current];
		current++;
	}
    return newone;
}

template <class M>
int Sequence<M>::subsearch(const Sequence<M> &n) const {
	int position,current=0;
	if(n.length>length) return -1;
	for(int i=0; i<length; i++) {
		if(arr[i]==n.arr[0]) {
			for(int j=i; j<n.length; j++) {
				if(arr[i]!=n.arr[current]) { 
					current=0; 
					break; 
				}
				current++;
			}
			if(current==n.length-1) return i;
		}
	}
	return -1;
}

template <class M>
void Sequence<M>::AllocateMemory(unsigned i) {
	length=0;
    max = i;
    arr = new M[i];
}

template <class M>
void Sequence<M>::FreeMemory() {
	length=max=0;
    delete [] arr;
}




//Vtora zada4a


//po ideia tozi klas triabva da e abstrakten, t.e. interfeis samo s virtualni fukcii
//(zashtoto ne se predpolaga klas, definirasht prosto nabor ot operacii, da ima danni), no e ok i taka
class Operations {
	protected:
		double *arr;
		int length;
	public:
		Operations(const Operations &);
		virtual double operator()() const;
		virtual double operator[](int) const;
		virtual Operations operator*(double) const;
		virtual Operations operator+(const Operator &) const;
};

Operations::Operations(const Operations &n) {
	length = n.length;
	arr = new double [length];
	for(int i=0; i<length; i++) {
		arr[i] = n.arr[i];
	}
}

class Vector: public Operations {
	public:
		Vector(const Vector &);
		virtual double operator()() const;
		virtual double operator[](int) const;
		virtual Vector operator+(const Vector &) const; //triabva da vrushtat Operations, inache niama da se kompilira; Vector se castva do Operations avtomatichno
		virtual Vector operator*(double) const;
};

Vector::Vector(const Vector &n):Operations(n) {}

double Vector::operator()() const {
	return length;
}

double Vector::operator[](int n) const {
	if(n>length) return 0;
	return arr[n-1];				//Ako ot4itame nulata, ako ne ia ot4itame bez - 1
}

Vector Vector::operator*(double n) const {
	Vector newone(*this);
	for(int i=0; i<length; i++) {
		newone.arr[i] *= n;
	}
	return newone;
}

Vector Vector::operator+(const Vector &n) const {
	Vector newone(*this);
	if(length!=n.length) {
		cout<<"Nesarazmernost";
		return newone;
	}
	for (int i=0; i<length; i++) {
		newone.arr[i] += n.arr[i];
	}
	return newone;
}

class Polynome: public Operations {
	public:
		Polynome(const Polynome &);
		virtual double operator()() const;
		virtual double operator[](int) const;
		virtual Polynome operator*(double) const; //i tuk taka
		virtual Polynome operator+(const Polynome &) const;
};

Polynome::Polynome(const Polynome &n):Operations(n) {}

double Polynome::operator()() const {
	return length;
}

double Polynome::operator[](int n) const {
	double sum = 0;
	for(int i=0; i<length; i++) {
		sum += pow(n*arr[i], i);
	}
	return sum;
}

Polynome Polynome::operator*(double n) const {
	Polynome newone(*this);
	for(int i=0; i<length; i++) {
		newone.arr[i] *= n;
	}
	return newone;
}

Polynome Polynome::operator+(const Polynome &n) const {
	Polynome newone(*this);
	if(length != n.length) {
		cout<<"Nesarazmerni sa"; return newone;
	}
	for(int i=0; i<length; i++) {
		newone.arr[i] += n.arr[i];
	}
	return newone;
}
//Nqmam vreme za sujalenie
int main() {/*
	Operations *neew;
	neew = new Operations[10];
	int sum, val;
	for(int i=0; i<10; i++) {
		neew[i][val]
	}*/
	return 0;
}
